<?php
/**
 * Cleantalk JComments handler
 *
 * @version 0.1
 * @package Cleantalk
 * @subpackage JComments
 * @author Сleantalk team (shagimuratov@cleantalk.ru)
 * @copyright (C) 2011 Сleantalk team (http://cleantalk.ru)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 */

class CleantalkHandler_jcomments
{
	/**
	 * Function for check comment in JCommentsAJAX
	 * @param JCommentsDB $comment
	 * @return bool
	 */
	function checkComment(&$comment)
	{
		// Get base text:

		switch($comment->object_group)
		{
			case 'com_content':
				$article = & JTable::getInstance('content');
				$article->load($comment->object_id);
				$baseText = $article->introtext . '<br>' . $article->fulltext;
			break;
			default:
				$baseText = '';
		}

		// Get previous comments:

		$db = & JCommentsFactory::getDBO();
		$query = "SELECT comment "
				. "\nFROM #__jcomments "
				. "\nWHERE published = 1 "
				. "\n  AND object_group = '" . $db->getEscaped($comment->object_group) . "'"
				. "\n  AND object_id = " . $comment->object_id
				. (JCommentsMultilingual::isEnabled() ? "\nAND lang = '" . JCommentsMultilingual::getLanguage() . "'" : "")
				. " ORDER BY id DESC "
				. " LIMIT 10 "
				;
		$db->setQuery($query);
		$prevComments = $db->loadResultArray();
		$prevComments = $prevComments == NULL ? '' : implode("\n\n", $prevComments);

		// Request:
		
		$ctResponse = NULL;
		plgSystemCleantalk::isAllowMessage(array(
			'base_text'=> ($baseText . "\n\n\n\n" . $prevComments),
			'user_name'=>$comment->name,
			'user_email'=>$comment->email,
			'message'=>$comment->comment,
			'engine'=>'joomla',
			'url'=>'',
			'stoplist_check'=>'0',
			'session_ip'=>$comment->ip,
		), $ctResponse);

		if(!empty($ctResponse) && is_array($ctResponse))
		{
			if($ctResponse['blacklisted'] > 0)
			{
				JCommentsAJAX::showErrorMessage($ctResponse['comment'], 'comment');
				return false;
			}
			else if($ctResponse['allow'] == 0)
			{
				$comment->published = false;
				$ct = plgSystemCleantalk::Cleantalk();
				$comment->comment = $ct->addCleantalkComment($comment->comment, $ctResponse['comment']);
			}
		}

		return true;
	}

	/**
	 * Function for moderate in Admin.JComments
	 * @param $comment_ids
	 * @param $publish
	 * @return void
	 */
	function adminJcModerate($comment_ids, $publish)
	{
		if(!is_array($comment_ids))
			$comment_ids = array($comment_ids);

		$db = & JCommentsFactory::getDBO();
		$comments = $row = array();
		foreach($comment_ids as $id)
		{
			$row[$id] = new JCommentsDB($db);
			if ($row[$id]->load($id))
				$comments[$id] = $row[$id]->comment;
		}

		plgSystemCleantalk::moderateMessages(&$comments, $publish);

		foreach($comment_ids as $id)
		{
			$row[$id]->comment = $comments[$id];
			$row[$id]->store();
		}
	}


}