<?php
/**
 * Cleantalk joomla plugin
 * 
 * @version 0.1
 * @package Cleantalk
 * @subpackage Joomla
 * @author Сleantalk team (shagimuratov@cleantalk.ru)
 * @copyright (C) 2011 Сleantalk team (http://cleantalk.ru)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 */

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.plugin.plugin' );

class plgSystemCleantalk extends JPlugin
{
	/**
	 * Constructor
	 * @param $subject
	 * @param $config
	 * @return void
	 */
	function plgSystemCleantalk( &$subject, $config )
	{
		parent::__construct( $subject, $config );
		$this->_plugin = JPluginHelper::getPlugin( 'system', 'cleantalk' );
      $this->_params = new JParameter( $this->_plugin->params );
	}

	/**
	 * Function for create Cleantalk object
	 * @return Cleantalk
	 */
	function Cleantalk()
	{
		$plugin = JPluginHelper::getPlugin( 'system', 'cleantalk' );
		$jparams = new JParameter( $plugin->params );

		$lang = & JFactory::getLanguage();
		$langTag = substr($lang->getTag(), 0, 2);

		require_once (dirname(__FILE__).DS.'cleantalk.class.php');
		return new Cleantalk(array(
			'auth_key' => $jparams->def('apikey', ''),
			'response_lang' => $langTag,
			'server_url' => $jparams->def('server', ''),
		));
	}

	/**
	 * Function for check message
	 * @param $params
	 * @param $response
	 * @return bool|int
	 */
	function isAllowMessage($params, &$response)
	{
		$cleantalk = self::Cleantalk();
		$result = $cleantalk->isAllowMessage($params,$response);

		if($response == NULL)
		{
			$response = array(
				'allow'=>0,
				'comment'=>'Can\'t connect to cleantalk.ru',
				'blacklisted'=>0,
			);
		}

		return $result;
	}

	/**
	 * Function to send the results of moderation
	 * @param $message
	 * @param $allow
	 * @return void
	 */
	function moderateMessage(&$message, $allow)
	{
		$cleantalk = self::Cleantalk();
		$hash = $cleantalk->getCleantalkCommentHash($message);
		$resultMessage = $cleantalk->delCleantalkComment($message);

		if($hash != NULL)
		{
			$ctFbParams = array(
				'moderate'=>array(
					array('msg_hash'=>$hash, 'is_allow'=>$allow),
				),
			);

			$ct_response = NULL;
			$cleantalk->sendFeedback($ctFbParams, &$ct_response);
		}

		$message = $resultMessage;
	}

	/**
	 * Function to send the results of moderation many messages
	 * @param $messages
	 * @param $allow
	 * @return void
	 */
	function moderateMessages(&$messages, $allow)
	{
		$cleantalk = self::Cleantalk();
		$ctFbParams = array('moderate'=>array(),);

		foreach($messages as $id => $message)
		{
			$hash = $cleantalk->getCleantalkCommentHash($message);
			$messages[$id] = $cleantalk->delCleantalkComment($message);

			if($hash != NULL)
				$ctFbParams['moderate'][] = array('msg_hash'=>$hash, 'is_allow'=>$allow);
		}

		if(!empty($ctFbParams['moderate']))
		{
			$ct_response = NULL;
			$cleantalk->sendFeedback($ctFbParams, &$ct_response);
		}
	}

	/**
	 * Function for load special handler
	 * @param $name
	 * @return
	 */
	function loadHandler($name)
	{
		require_once (dirname(__FILE__).DS.'cleantalk.'.$name.'.php');
		$class = 'CleantalkHandler_'.$name;
		return new $class();
	}
}
